//!
//! bloom shader..
//!
//! Needs a noise map for some extra stuff..
//!

varying lowp vec4 DstColour;
varying lowp vec2 TexCoordOut;
uniform sampler2D Texture;

//! intensity of effect..
uniform lowp float fEffect;

void main(void)
{
    lowp vec2 uv = TexCoordOut.xy;
    lowp vec3 col[9];
    col[0] = texture2D( Texture, uv ).xyz;
    lowp float fDistance = 0.002;
    lowp vec3 dotP = vec3(0.1,0.1,0.1);
    
    //col = oricol;
    col[1] = texture2D(Texture,vec2(uv.x-fDistance, uv.y)).xyz;
    col[2] = texture2D(Texture,vec2(uv.x-fDistance/2.0, uv.y-fDistance)).xyz;
    col[3] = texture2D(Texture,vec2(uv.x+fDistance/2.0, uv.y+fDistance)).xyz;
    col[4] = texture2D(Texture,vec2(uv.x+fDistance, uv.y)).xyz;
    col[5] = texture2D(Texture,vec2(uv.x-fDistance*2.0, uv.y)).xyz;
    col[6] = texture2D(Texture,vec2(uv.x-fDistance*3.0, uv.y+fDistance*2.0)).xyz;
    col[7] = texture2D(Texture,vec2(uv.x+fDistance*3.0, uv.y-fDistance*2.0)).xyz;
    col[8] = texture2D(Texture,vec2(uv.x+fDistance*2.0, uv.y)).xyz;
    
    //col[0] *= dot(col[0], vec3(dotP,dotP,dotP));
    col[1] *= dot(col[1], dotP);
    col[2] *= dot(col[2], dotP);
    col[3] *= dot(col[3], dotP);
    col[4] *= dot(col[4], dotP);
    col[5] *= dot(col[5], dotP);
    col[6] *= dot(col[6], dotP);
    col[7] *= dot(col[7], dotP);
    col[8] *= dot(col[8], dotP);
    
    // Merge
    lowp float blur = fEffect * 0.5;
    lowp float main = 1.0 - blur;
    
    lowp vec3 bloom = (col[1]+col[2]+col[3]+col[4]+col[5]+col[6]+col[7]+col[8]);
    bloom = bloom*bloom;
    bloom = blur*bloom;
    lowp vec3 outcol = main*col[0] + bloom;
    
    //! Scanline
    //col *= 0.9 + sin(uv.y*800.0) * 0.1;
    
    // Tone Map
    //col *= vec3(1.06,1.03,0.95);
    
    gl_FragColor.xyz = outcol.xyz;
    gl_FragColor.w = 1.0;
}
