varying lowp vec4 DstColour;

varying lowp vec2 TexCoordOut;
uniform sampler2D Texture;

uniform highp vec3 iHSVMod;


mediump vec3 rgb2hsv(lowp vec3 c)
{
    mediump vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    mediump vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    mediump vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    mediump float d = q.x - min(q.w, q.y);
    mediump float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

lowp vec3 hsv2rgb(mediump vec3 c)
{
    highp vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    highp vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main(void)
{
    gl_FragColor = texture2D( Texture, TexCoordOut );

    mediump vec3 diff_hsv = rgb2hsv( gl_FragColor.rgb );
    
    diff_hsv += iHSVMod;
    
    gl_FragColor.rgb = hsv2rgb( diff_hsv );
}