varying lowp vec4 DstColour;
varying highp vec2 TexCoordOut;
uniform sampler2D Texture;
uniform lowp vec4 gradientColour;


// Example (image used should be grayscale)
// **** DstColour(vert SrcColour) must be set, or you'll probably get black/solid textures;
//
//  CVec4* gradientColour = new CVec4(128.0/255.0,	41.0/255.0, 	7.0/255.0,		1);
//
//	CRenderSystem::SetShaderParameter(COLOURIZE_SHADER_ID, "gradientColour", gradientColour, sizeof(CVec4), 0);

void main(void)
{
    mediump vec4 sampleColour = texture2D(Texture, TexCoordOut) * DstColour;
	mediump float sampleGray = 0.3 * sampleColour.r + 0.59 * sampleColour.g + 0.11 * sampleColour.b;
    
    gl_FragColor.rgb = vec3(sampleGray) * gradientColour.rgb;
    gl_FragColor.a = sampleColour.a * DstColour.a;
}