attribute vec4 Pos;
attribute lowp vec4 SrcColour;

varying lowp vec4 DstColour;
varying lowp float Fog;
varying lowp float FogRest;
uniform lowp float FogMaxHeight;
uniform lowp float FogMinHeight;

uniform mat4 ModelViewProj;

attribute vec2 TexCoordIn;
varying vec2 TexCoordOut;

void main(void)
{
	DstColour = SrcColour;
	gl_Position = ModelViewProj * Pos;
	TexCoordOut = TexCoordIn;

	Fog = clamp( ( Pos.z - FogMinHeight ) / ( FogMaxHeight - FogMinHeight ), 0.0, 1.0 );
	FogRest = 1.0 - Fog;
}