//!
//! CRT style shader..
//!
//! Needs a noise map for some extra stuff..
//!

varying lowp vec4 DstColour;
varying lowp vec2 TexCoordOut;
uniform sampler2D Texture;

//! intensity of effect..
uniform lowp float fEffect;

void main(void)
{
    lowp vec2 uv = TexCoordOut.xy;
    lowp vec3 col;
    lowp vec3 oricol = texture2D( Texture, uv ).xyz;
	
    col = oricol;
    col += texture2D(Texture,vec2(uv.x-0.004, uv.y)).xyz;
    col += texture2D(Texture,vec2(uv.x-0.002, uv.y)).xyz;
	col += texture2D(Texture,vec2(uv.x+0.002, uv.y)).xyz;
    col += texture2D(Texture,vec2(uv.x+0.004, uv.y)).xyz;
    
	// Merge
    lowp float blur = fEffect * 0.5;
    lowp float main = 1.0 - blur;
    col = ((main * oricol) + (col*blur));
    
    //! Scanline
    col *= 0.9 + sin(uv.y*800.0) * 0.1;
    
	// Tone Map
    col *= vec3(1.06,1.03,0.95);
    
    gl_FragColor.xyz = col.xyz;
    gl_FragColor.w = 1.0;
}
